
import React, { useEffect } from 'react';
import style from './index.module.less';
import { DatePicker, RangePicker } from 'mayihr-components'
import moment from 'moment'


export default (props) => {
    useEffect(() => {
        if (props.data.default.value && !props.value && props.parent.lastIndexOf('#/Search_') !== -1) {
            props.dispatchEvent('onChange', { props, value: props.data.default.value })
        }
    }, [])
    let styleC = null
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : {}
        styleC.width = styleC && styleC.width ? styleC.width : (props.parent.lastIndexOf('#/Form_') !== -1 ? '100%' : 200)
    } catch (error) {

    }
    const sytleOption = styleC
    const onChange = (date, dateString) => {
        props.dispatchEvent('onChange', { props, value: { date, dateString } })
    }
    const labelRender = () => props.data.label.value ? <div className={style.labelClass}>{props.data.label.value}</div> : null
    const type = props.style.type.value === 'multiline' ? 'multiline' : 'single'
    const renderDate = () => {
        if (type === 'single') {
            return <DatePicker style={sytleOption} onChange={onChange} defaultValue={props.value ? moment(props.value) : props.data.default.value}></DatePicker>
        }
        let data = []
        if (props.value) {
            props.value.map(item => {
                data.push(moment(item))
            })
        }
        return <RangePicker style={sytleOption} onChange={onChange} defaultValue={props.value ? data : props.data.default.value}></RangePicker>
    }
    return <div className={props.parent.lastIndexOf('#/Form_') === -1 ? style.datePickerContent : style.fromDatePicker}>
        {labelRender()}
        <div className={style.picker}>{renderDate()}</div>
    </div>
}

