
import React, { useEffect, useState } from 'react';
// import ReactDOM from 'react-dom'
import style from './index.module.less';
import { Button } from 'mayihr-components'
import IndexCom from './index'
import { dealData } from '../Util/Tool'
import {
    MinusCircleOutlined,
} from '@ant-design/icons';


export default (props) => {
    const [childrenList, setChildrenList] = useState([])
    useEffect(() => {
        console.log(props.formValue, 'props.formValueprops.formValueprops.formValue')
        setChildrenList(props.formValue)
    }, [props.formValue])
    let styleC = {}
    const addElementId = 'From' + Math.floor(new Date().getTime() * Math.random())
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : {}
    } catch (error) {

    }
    const styledata = { ...styleC }
    const renderEdit = () => {
        return props.edit ? <div className={style.addElement} style={{ margin: 20 }}>拖拽增加元素</div> : null
    }
    const sureClick = () => {
        props.dispatchEvent('onSubmit', { props })
    }
    const cancelClick = () => {
        props.dispatchEvent('onCancel', { props })
    }
    // 添加子元素
    const addElement = () => {
        let data = { ...childrenList[0] }
        for (let i in data) {
            data[i] = ''
        }
        childrenList.push(data)
        setChildrenList([...childrenList])
        props.dispatchEvent('onArrayEdit', { props, childrenList })
    }
    // 删除子元素
    const subElement = (index) => {
        childrenList.splice(index, 1)
        setChildrenList([...childrenList])
        props.dispatchEvent('onArrayEdit', { props, childrenList })
    }
    const childrenForm = props.parent.lastIndexOf('#/Form') !== -1 && props.componetType === 'Form' ? true : false
    const addBtnRender = () => {
        return props.style.addButton && props.style.addButton.value === 'hide' ? null : <div className={style.addBtn}><Button type="Text" onClick={addElement} style={{ color: "#34AC37" }} >添加选项</Button></div>
    }
    const renderChildren = (index) => {
        return childrenList.length === 0 ? <div style={{ position: 'relative' }} >
            <div className={`${style[props.style.lineMode.value ? props.style.lineMode.value : 'one']} ${style.form}`}>{props.children}</div>
            <div className={style.subBtn}>{props.style.addButton && props.style.addButton.value === 'hide' ? null : <MinusCircleOutlined onClick={() => { subElement(index) }} />}</div>
        </div> : renderListChildren()
    }
    // 子元素的值改吧
    const getFromChildrenChange = (e, value) => {
        const pos = value.props.id.split('_formChildrenIndex_')[1]
        const bind = value.props.data.bind.value
        childrenList[pos][bind] = value.value
        props.dispatchEvent('onArrayEdit', { props, childrenList })
    }
    const renderListChildren = () => {
        return childrenList.map((item, index) => (
            <div style={{ position: 'relative', marginBottom: '20px' }} key={index}>
                <div className={`${style[props.style.lineMode.value ? props.style.lineMode.value : 'one']} ${style.form}`}>
                    {props.childrenItems.map((citem, cindex) => {
                        let render = { ...citem }
                        render.id = (render.id + '_formChildrenIndex_' + index)
                        render.dispatchEvent = (e, value) => {
                            getFromChildrenChange(e, value)
                        }
                        render.value = item[dealData(citem.data).bind.value]
                        return <IndexCom {...render} key={cindex}></IndexCom >
                    })}
                </div>
                <div className={style.subBtn}>
                    {props.style.addButton && props.style.addButton.value === 'hide' ? null : <MinusCircleOutlined onClick={() => { subElement(index) }} />}
                </div>
            </div>
        ))

    }
    return <div className={style.formContent} style={props.edit ? {} : { border: 0 }}>
        <div style={styledata}>
            <div className={style.flexall}>
                {props.data.label.value ? <p className={style.areaTitle}>{props.data.label.value}</p> : null}
                {childrenForm ? addBtnRender() : null}
            </div>
            {childrenForm ? <div id={addElementId}> {renderChildren()}</div> : <div className={`${style[props.style.lineMode.value ? props.style.lineMode.value : 'one']} ${style.form}`}>{props.children}</div>}
            {childrenForm ? null : <div className={style.buttonContent}>
                {props.style.submitButton.value === 'hide' ? null : <Button type="primary" onClick={sureClick} style={{ marginRight: 10 }}>确认</Button>}
                {props.style.cancelButton.value === 'hide' ? null : <Button onClick={cancelClick}>取消</Button>}
            </div>}
            {renderEdit()}
        </div>
    </div>
};

