
import React, { useState, useEffect } from 'react';
import style from './index.module.less';
import { Input, InputNumber, TextArea } from 'mayihr-components'
import { regData } from '../Util/Tool'


export default (props) => {
    const [rangeData, setRangeData] = useState([])
    const [error, setError] = useState('')
    useEffect(() => {
        if (props.data.default.value && !props.value && props.parent.lastIndexOf('#/Search_') !== -1) {
            props.dispatchEvent('onChange', { props, value: props.data.default.value })
        }
    }, [])
    let styleC = {}
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : {}
    } catch (error) {

    }
    let defalutWidth = 200
    let fromClass = ''
    if (props.parent.lastIndexOf('#/Form_') !== -1) {
        defalutWidth = '100%'
        fromClass = style.fromInput
    }
    const sytleOption = styleC ? {
        background: props.style.background.value ? props.style.background.value : null,
        color: props.style.color.value ? props.style.color.value : null,
        width: props.style.width.value ? props.style.width.value : defalutWidth,
        height: props.style.height.value ? props.style.height.value : 32,
        textAlign: props.style.textAlign.value ? props.style.textAlign.value : 'left',
        ...styleC
    } : {
        background: props.style.background.value ? props.style.background.value : null,
        color: props.style.color.value ? props.style.color.value : null,
        width: props.style.width.value ? props.style.width.value : defalutWidth,
        height: props.style.height.value ? props.style.height.value : 32,
        textAlign: props.style.textAlign.value ? props.style.textAlign.value : 'left',
    }
    const labelRender = props.data.label.value ? <div className={style.labelClass}>{props.data.label.value}</div> : null
    const prefixRender = props.data.prefix.value ? <span className={style.prefix} style={{ lineHeight: sytleOption.height + 'px' }}>{props.data.prefix.value}</span> : null
    const errorRender = error ? <p className={style.error} >{error}</p> : null
    console.log(error)
    const onChangeEvent = (e) => {
        // console.log(props.data.customRegx)
        if (props.data.customRegx && props.data.customRegx.value) {
            const testReg = props.data.customRegx.value.substr(1, props.data.customRegx.value.length - 2)
            if (!new RegExp(testReg).test(e)) {
                setError(props.data.error && props.data.error.value ? props.data.error.value : '格式有误')
                return
            } else {
                setError('')
            }
        }
        if (props.data.regx.value) {
            const reg = regData(props.data.regx.value, e)
            if (!reg) {
                setError(props.data.error && props.data.error.value ? props.data.error.value : '格式有误')
                return
            } else {
                setError('')
            }
        }
        let dataValue = !isNaN(e) ? e : e.toString().replace(/(^\s*)|(\s*$)/g, "")
        if (!e) {
            dataValue = e
        }
        props.dispatchEvent('onChange', { props, value: dataValue })
    }
    const rangeOnChangeEvent = (e, index) => {
        const newRangeData = [...rangeData]
        newRangeData[index] = e * 1
        if (newRangeData[1 - index] || newRangeData[1 - index] === 0) {
            if (newRangeData[0] > newRangeData[1]) {
                setError(props.data.error && props.data.error.value ? props.data.error.value : '前面的数字不能大于后面')
                return
            }
        }

        setRangeData(newRangeData)
        props.dispatchEvent('onChange', { props, value: newRangeData })
    }

   //  console.log(props, 'input')
    const singleInput = <div className={fromClass}>
        {labelRender}
        <div className={style.inputContent}>
            {prefixRender}
            <div className={style.inputMain}>
                <Input
                    style={sytleOption}
                    placeholder={props.data.placeholder.value ? props.data.placeholder.value : '请输入'}
                    defaultValue={props.value ? props.value : props.data.default.value}
                    //value={props.value ? props.value : props.data.default.value}
                    onFocus={() => {
                        setError('')
                    }}
                    onChange={(e) => {
                        onChangeEvent(e.currentTarget.value)
                    }}>
                </Input>
                {errorRender}
            </div>
        </div>
    </div>

    const multilineInput = <div className={fromClass}>
        {labelRender}
        <div className={style.inputContent}>
            {prefixRender}
            <div className={style.inputMain}>
                <TextArea
                    style={sytleOption}
                    placeholder={props.data.placeholder.value ? props.data.placeholder.value : '请输入'}
                    defaultValue={props.value ? props.value : props.data.default.value}
                    onFocus={() => {
                        setError('')
                    }}
                    onChange={(e) => {
                        onChangeEvent(e.currentTarget.value)
                    }}>
                </TextArea>
                {errorRender}
            </div>
        </div>
    </div>

    const rangeInput = <div className={fromClass}>
        {labelRender}
        <div className={style.inputContent}>
            {prefixRender}
            <div className={style.inputMain}>
                <div style={{ float: 'left' }}>
                    <InputNumber
                        style={{ ...sytleOption }}
                        placeholder={props.data.placeholder.value ? props.data.placeholder.value : '请输入'}

                        defaultValue={props.value ? props.value[0] : props.data.default.value}
                        onFocus={() => {
                            setError('')
                        }}
                        onChange={(e) => {
                            rangeOnChangeEvent(e, 0)
                        }}>
                    </InputNumber>
                </div>
                <span style={{ float: 'left', lineHeight: sytleOption.height + 'px', margin: '0 5px' }}>-</span>
                <div style={{ float: 'left' }}>
                    <InputNumber
                        style={{ ...sytleOption }}
                        placeholder={props.data.placeholder.value ? props.data.placeholder.value : '请输入'}
                        defaultValue={props.value ? props.value[1] : props.data.default.value}
                        onFocus={() => {
                            setError('')
                        }}
                        onChange={(e) => {
                            rangeOnChangeEvent(e, 1)
                        }}>
                    </InputNumber>
                </div>
                {errorRender}
            </div>
        </div>
    </div>
    switch (props.style.type.value) {
        case "single":
            return singleInput
            break
        case "multiline":
            sytleOption.height = 'auto'
            return multilineInput
            break
        case "range":
            return rangeInput
            break
        default:
            return singleInput
    }

};

