
import React, { useEffect, useState } from 'react';
import style from './index.module.less';
import { Button } from 'mayihr-components'
import { DownOutlined, UpOutlined } from "@ant-design/icons";
export default (props) => {
    const [open, setOpen] = useState(false)
    const [saheight, setsaheight] = useState(32)
    const [line, setLine] = useState(true)
    const searchId = "a" + Math.random(new Date().getTime())
    useEffect(() => {
        // console.log(document.getElementById(searchId))
        if (document.getElementById(searchId)) {
            const childerLength = document.getElementById(searchId).childNodes.length
            const divRange = document.getElementById(searchId).getClientRects()
            if (divRange[0].width <= childerLength * 210) {
                setLine(true)
            } else {
                setLine(false)
            }
        }
    }, [])
    let styleC = null
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : null
    } catch (error) {

    }
    const config = { background: props.style.background.value ? props.style.background.value : 'transparent' }
    const styledata = styleC ? { ...config, ...styleC } : { ...config }

    const renderEdit = () => {
        return props.edit ? <div className={style.addElement} >拖拽增加元素</div> : null
    }
    const resetAll = () => {
        props.dispatchEvent('onReset', { props })
    }
    const HVClass = `${style.search} ${style.flextabel}`
    let LRClass = `${HVClass}`

    if (!props.children) {
        return <div className={style.searchContent}>{renderEdit()}</div>
    }
    return <div className={style.searchContent}>
        <div className={style.flexall} style={styledata}>
            <div className={LRClass} style={{ height: saheight }} id={searchId}>{props.children}</div>
            <div className={style.buttonC} >
                <Button onClick={resetAll}>重置</Button>
                {line ? <Button type="Text" onClick={() => {
                    if (!open) {
                        setsaheight('auto')
                    } else {
                        setsaheight(32)
                    }
                    setOpen(!open)
                }}>{open ? "收起" : '展开'}{open ? <UpOutlined /> : <DownOutlined />}</Button> : null}
            </div>
        </div>
    </div>

};

