
import React, { useEffect, useState } from 'react';
import style from './index.module.less';
import { Table } from 'mayihr-components'
import { dealData } from '../Util/Tool'
import Global from '../Util/Global';
import moment from 'moment'


export default (props) => {
    const [pag, setP] = useState(false)
    useEffect(() => {
        let pagination = false
        try {
            pagination = props.style.pagination.value ? { ...JSON.parse(props.style.pagination.value) } : {}
            pagination.total = 100
            pagination.showTotal = (total) => { return `总数：${total} ` }
        } catch (error) {

        }
        // pagination.total = props.value ? props.value.total : 0
        setP(pagination)
    }, [])
    useEffect(() => {
        const pageInfo = !props.edit && props.id && Global.VariablePool.refs[props.id].request ? { current: Global.VariablePool.refs[props.id].request.page + 1, pageSize: Global.VariablePool.refs[props.id].request.size } : null
        // console.log(pageInfo)
        setP({ ...pag, total: props.value ? props.value.total : 0, ...pageInfo, showTotal: (total) => { return `总数：${total} ` } })
    }, [props.value])
    let styleC = {}
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : {}
    } catch (error) {

    }

    const styledata = { ...styleC, position: 'relative' }
    const columnsApi = [];
    const templateData = {}
    const translate = {}
    // 渲染table表头
    if (props.data.columnConfig.value) {
        props.data.columnConfig.value.map(item => {
            let data = {}
            item.map(citem => {
                data[citem.key] = citem.value
                if (citem.key === 'width') {
                    data.width = data.width * 1
                }
                if (citem.key === 'ellipsis') {
                    data.ellipsis = data.ellipsis === 'true' ? true : false
                }
                if (citem.key === 'dataIndex') {
                    data["key"] = citem.value
                    templateData[citem.value] = ""
                }
                if (citem.key === 'translation' && citem.value) {
                    try {
                        translate[data["key"]] = JSON.parse(citem.value)
                        data["key"] = data["key"] + 'show'
                        data["dataIndex"] = data["key"]
                    } catch (error) {
                        console.log('json parse fail', error)
                    }
                }
            })
            columnsApi.push(data)
        })
    }
    // 渲染table动作
    if (props.data.action.value) {
        const actionObj = []
        props.data.action.value.map(item => {
            let data = {}
            item.map(citem => {
                data[citem.key] = citem.value
            })
            actionObj.push(data)
        })
        const action = {
            title: '操作',
            dataIndex: 'action',
            key: 'action',
            fixed: "right",
            width: props.data.action.value.length * (props.data.action.value.length == 1 ? 60 : 50),
            render: (text, record) =>
                <span>{props.data.action.value.map((item, index) => (
                    <a style={{ marginRight: 8 }} key={index} onClick={() => {
                        props.dispatchEvent('actionClick', { props, value: { item: text, record, action: actionObj[index] } })
                    }}>{actionObj[index].name}</a>
                ))}
                </span>

        }
        columnsApi.push(action)
    }
    const renderEdit = () => {
        return props.edit ? <div className={style.addElement} style={{ margin: 20 }}>配置表格的列</div> : null
    }
    if (columnsApi.length === 0) {
        return renderEdit()
    }
    props.value && props.value.list.map((litem, index) => { litem.key = litem.key ? litem.key : index })
    const data = props.value ? props.value.list : [];
    data.map(item => {
        item.indexFrontendKeyId = item.code
        for (let i in item) {
            if (translate[i] && !translate[i].moment) {
                if (item[i] !== undefined || item[i] != null) {
                    item[i + 'show'] = translate[i][item[i]]
                }
            }
            if (translate[i] && translate[i].moment) {
                if (item[i] !== undefined || item[i] != null) {
                    item[i + 'show'] = moment(item[i]).format("YYYY-MM-DD")
                }
            }
        }
    })
    let controlShow = false
    // 渲染其它的事情
    if (props.style.controlShow.value && props.style.controlShow.value.length !== 0) {
        controlShow = {}
        props.style.controlShow.value.map(item => {
            switch (item) {
                case "columnHeight":
                    controlShow['ColumnHeightOutlined'] = true
                    break
                case "setting":
                    controlShow['SettingOutlined'] = true
                    break
                case "rowSelection":
                    controlShow['rowSelection'] = true
                    break
                case "reload":
                    controlShow['ReloadOutlined'] = true
                    break
                case "resizable":
                    controlShow['resizable'] = true
                    break
            }
        })
    }
    let headerButton = []
    if (props.childrenItems.length !== 0) {
        const icon = () => { }
        props.childrenItems.map(item => {
            const data = dealData(item.data)
            const style = dealData(item.style)
            headerButton.push({
                onClick: () => {
                    props.dispatchEvent('onTableHeaderClick', { props, value: item })
                },
                type: style.type.value || "primary",
                name: data.content.value || item.name,
                icon: data.icon.value || icon
            })
        })
    }
    const tableChange = (e) => {
        setP({ ...pag, ...e })
        props.dispatchEvent('onChange', { props, value: e })
    }
    const tableRowsChange = (selectedRowKeys, selectedRows) => {
        const returnRow = { code: selectedRows.map(item => { return item.indexFrontendKeyId }) }
        props.dispatchEvent('onTableRowsChange', { props, value: { selectedRowKeys, selectedRows, returnRow } })

        console.log(selectedRowKeys, selectedRows, returnRow)
    }
    let px = 0
    let tpx = 0
    if (styleC.padding) {
        const pxx = styleC.padding.split(" ")
        switch (pxx.length) {
            case 1:
                px = pxx[0].replace('px', '') * 1
                tpx = pxx[0].replace('px', '') * 1
                break
            default:
                px = pxx[1].replace('px', '') * 1
                tpx = pxx[0].replace('px', '') * 1
                break
        }
    }
    // const px = styleC.padding ? styleC.padding.replace('px', '') * 1 : 0
    // console.log(styleC.padding)
    // console.log(controlShow['rowSelection'], 'rowSelectionrowSelectionrowSelection', props.style.controlShow.value)
    const getLenght = controlShow['rowSelection'] ? (props.style.controlShow.value.length - 1) : (props.style.controlShow.value ? props.style.controlShow.value.length : 0)
    // console.log(getLenght)
    const rightGo = props.style.controlShow.value ? (px + 30 * getLenght) : 0
    const topGo = tpx + 9
    // console.log(rightGo, topGo)
    return <div className={style.tableContent} >
        <div style={styledata}>
            <Table columns={columnsApi}
                key={new Date().getTime()}
                headerButton={headerButton}
                headName={props.data.label.value ? props.data.label.value : null}
                dataSource={data}
                controlShow={controlShow}
                pagination={pag}
                rowSelection={controlShow['rowSelection'] ? { onChange: tableRowsChange } : controlShow['rowSelection']}
                scroll={{ x: '100%' }}
                onChange={tableChange}
                borderedHeader={true}
                maxChoose={12}
                resizable={controlShow['resizable'] ? true : false}
            ></Table>
            {props.edit ? <div className={style.buttonedit} style={{ right: rightGo, top: topGo }}>{props.children}</div> : null}
        </div>
    </div>
};

