
import React from 'react';
import style from './index.module.less';
import { Button, Toast } from 'mayihr-components'

import { UploadOutlined } from '@ant-design/icons';

export default (props) => {
    const fileInputId = "file_" + Math.floor(Math.random() * new Date().getTime())
    const addFile = () => {
        document.querySelector("#" + fileInputId).click();
    };
    const inputOnChange = (e) => {
        const data = e.currentTarget.files[0]
        if (props.data.fileType.value) {
            const typeExit = props.data.fileType.value.filter(item => {
                return data.lastIndexOf(item) !== -1
            })
            if (typeExit.length === 0) {
                let fileInput = document.querySelector("#" + fileInputId)
                fileInput.outerHTML = fileInput.outerHTML
                Toast.error("message", "上传的格式不符合要求")
                return
            }
        }
        const fromData = new FormData();
        fromData.append('countLimit', -1);
        fromData.append('download', true);
        fromData.append('file', data);
        fromData.append('overtime', -1);
        props.dispatchEvent('file', { props, value: fromData })
    }
    let styleC = {}
    try {
        styleC = props.style.style.value ? { ...JSON.parse(props.style.style.value) } : {}
    } catch (error) {

    }
    const sytleOption = styleC ? {
        background: props.style.background.value ? props.style.background.value : null,
        ...styleC
    } : {
        background: props.style.background.value ? props.style.background.value : null,
    }
    return <>
        <Button onClick={addFile} style={sytleOption} size={!props.style.size.value ? 'middle' : props.style.size.value}>
            <UploadOutlined /> {props.data.content.value ? props.data.content.value : props.name}
        </Button>
        {props.data.file && props.data.file.value === "files" ? <input
            className={style.fileInput}
            type={"file"}
            multiple="multiple"
            name="file"
            id={fileInputId}
            onChange={inputOnChange}
        /> : <input
            className={style.fileInput}
            type={"file"}
            name="file"
            id={fileInputId}
            onChange={inputOnChange}
        />}

    </>
};

