import React from 'react'
import style from './index.module.less'
import ComponentRender from './ComponentRender'
import { dealData } from '../../Util/Tool'

function RenderChildren(props) {
  // console.log(props, 'RenderChildrenRenderChildren')
  const styleConfig = dealData(props.style)
  // 考虑排列方式为垂直和水平
  const getLineModeClass = () => {
    let returnClass = style.LMTBClass
    if (styleConfig.lineMode) {
      switch (styleConfig.lineMode.value) {
        case "horizontal":
          returnClass = styleConfig.textAlign && styleConfig.textAlign.value === 'right' ? style.LMTRClass : style.LMTLClass
          break
        case "vertical":
          returnClass = style.LMTBClass
          break
      }
    }
    return returnClass
  }
  // 一些特殊的css，form嵌套form，子form需要直接将宽度置为100%
  const spicealClass = (item) => {
    return item.type === 'Form' && item.parent.lastIndexOf('#/Form_') !== -1 ? style.containerSpecialClass : ''
  }
  // 根据组件mode，设置特殊的class样式，为未来的一些可能性做准备
  const modeClass = (mode) => {
    return mode === 'base' ? style.containerBClass : style.containerAClass
  }
  const LMTAClass = getLineModeClass()

  const renderChildren = (children) => {
    return children.map((item, index) => (<div key={index} className={`${LMTAClass} ${spicealClass(item)} ${modeClass(item.mode)}`} >
      <div className={style.containerClass}>
        <ComponentRender  {...item} edit={props.edit}>
          {item.childrenItems && item.childrenItems.length ? renderChildren(item.childrenItems) : null}
        </ComponentRender>
      </div>
    </div>))
  }
  // 这个地方需要考虑未来是否可以配置 对于这个margin默认有待真实使用后在考虑改怎么设置
  /**
   * 这里是让
  */
  return <div className={modeClass(props.mode)} style={{ marginBottom: 10 }}>
    <ComponentRender {...props}>
      {props.childrenItems && props.childrenItems.length ? renderChildren(props.childrenItems) : null}
    </ComponentRender>
  </div>

}

export default RenderChildren;


/// style={{ margin: '10px 0' }}