import React from 'react'
import style from './index.module.less'
import { Tabs, TabPane } from 'mayihr-components'
import RenderChildren from './RenderChildren'

/**
 * 
 * @param {data} props 
 * @returns 
 * 当前只是关注了
 */

function WidgetRender(props) {
  const Deal = (value) => {
    const returnD = {}
    value.map(item => {
      if (item.value) {
        //const itemCode = item.code === 'padding' ? "margin" : item.code
        if (item.code === 'padding' && props.data.type === "widget") {
          returnD["margin"] = !isNaN(item.value) ? (item.value * 1) : item.value
        }
        returnD[item.code] = !isNaN(item.value) ? (item.value * 1) : item.value
      }
    })
    return returnD
  }
  // 解析页面元素相关内容 主要为了tab页面做了一些特性化的东西
  let styleA = Deal(props.data.style)
  if (styleA.style) {
    styleA = { ...styleA, ...JSON.parse(styleA.style) }
  }
  const render = () => {
    const nowData = props.data
    // console.log(nowData, 'renderrender', nowData.tabList.length, nowData.type, nowData.tabList)
    if (nowData.type === "widget" && nowData.tabList.length > 1) {
      return (
        <div style={styleA}>
          <Tabs tabBarGutter={18}>
            {nowData.tabList.map(item => (<TabPane tab={item.name} key={item.key}>
              {item.childrenItems && item.childrenItems.map((item, index) => (<RenderChildren {...item} key={index} edit={false} ></RenderChildren>))}
            </TabPane>))}
          </Tabs>
        </div>
      )
    } else {
      return (
        <div>
          {nowData.tabList[0] && nowData.tabList[0].childrenItems.map((item, index) => (<RenderChildren {...item} key={index} edit={false} ></RenderChildren>))}
        </div>
      )
    }
  }
  return (
    <div className={style.widgetEdit}>
      {render()}
    </div>
  );
}
export default WidgetRender;
