import React, { createRef, useEffect, useState } from 'react'
import axios from '../../Util/RequestApi';
import style from './index.module.less'
import WidgetRender from './WidgetRender'
import Global from '../../Util/Global';
import { regData } from '../../Util/Tool'
// import Storage from '../../Util/Storage';

import { parseWidget, getAllCode, dealData, getRealUrl } from '../../Util/Tool'
import { Toast, Modal, Drawer, Button } from 'mayihr-components'
// import { dictBackend, interfaceBackEnd } from '../../Util/Dict'
// import { dictBackend } from '../../Util/Dict'
import ReactDOM from 'react-dom'
import ComponetsRender from './ComponentRender'
import { ConfigProvider } from 'antd';
import zhCN from 'antd/lib/locale/zh_CN';

import Api from '../Api'
let countTime = null
function initWidget(props) {
  let jsonData = typeof props.data === 'string' ? JSON.parse(props.data) : { ...props.data }
  const [visible, setVisible] = useState(true);
  const [endJSon, setEndJosn] = useState(null)
  useEffect(() => {
    makeData()
  }, [])
  useEffect(() => {
    if (endJSon) {
      initData()
    }
  }, [endJSon])
  if (props.config) {
    Global.VariablePool.process = props.config
  }

  const initData = async () => {
    // console.log(endJSon.content, 'initDatainitDatainitData', endJSon)
    for (let i in endJSon.content) {
      let urlData
      endJSon.content[i].data.map((ditem => {
        if (ditem.code === 'initData' && ditem.data && endJSon.content[i].type !== "Search") {
          urlData = ditem.data
        }
        if (ditem.code === "filter" && ditem.value) {
          urlData.initData = {}
          ditem.value.map(fitem => {
            let keyyy = ''
            let dvalue
            fitem.map(ffitem => {
              if (ffitem.key === "parpam") {
                keyyy = ffitem.value
              }
              if (ffitem.key === "value") {
                dvalue = ffitem.value
              }
            })
            urlData.initData[keyyy] = dvalue
          })
        }
      }))
      console.log(urlData, 'initDatainitDatainitData')
      if (urlData) {
        let url = urlData.url
        let initData = urlData.initData ? urlData.initData : { page: 0, size: 10 }
        if (Global.VariablePool.pageInit) {
          url = getRealUrl(url, Global.VariablePool.pageInit)
        }
        if (jsonData.childDataValue) {
          url = getRealUrl(url, jsonData.childDataValue)
        }
        console.log(url)
        // url = getRealUrl(url,)
        const data = await axios[urlData.method](url, initData);
        // console.log(data, endJSon.content[i], 'initDatainitDatainitDatainitData')
        if (endJSon.content[i].type !== 'Select') {
          window.setState(endJSon.content[i].id, data)
        }
        if (endJSon.content[i].type !== 'Table') {
          setChildItemData(endJSon.content[i].childrenItems, data)
        }
        if (endJSon.content[i].type === 'Select') {
          const selectType = dealData(endJSon.content[i].style).type
          const dataMap = JSON.parse(dealData(endJSon.content[i].data).mapping.value)
          if (selectType.value === 'normal') {
            let dataArr = []
            const backData = data.list ? data.list : data
            backData.map(item => {
              dataArr.push({ key: item[dataMap.key], label: item[dataMap.label] })
            })
            window.setOption(endJSon.content[i].id, dataArr)
          }
          console.log(endJSon.content[i])
        }
        window.setRequest(endJSon.content[i].id, initData, urlData)
      } else {
        if (endJSon.content[i].type === 'Form') {
          console.log(endJSon.content[i], jsonData.childDataValue)
          const variableData = endJSon.content[i].data.filter(item => { return item.code === "variable" })
          if (variableData[0] && jsonData.childDataValue) {
            if (variableData[0].value && jsonData.childDataValue[variableData[0].value]) {
              setChildItemData(endJSon.content[i].childrenItems, jsonData.childDataValue[variableData[0].value])
            }
          }
        }
      }
    }
  }
  // 当form出现内部嵌套的时候，需要一层层向下
  const setChildItemData = (children, data) => {
    children.map(item => {
      if (item.type !== "Form" && item.type !== "Area") {
        const bindKey = dealData(item.data).bind
        if (bindKey.value) {
          // console.log(item, 'initDate')
          window.setState(item.id, data[bindKey.value])
        }
      } else {
        const variable = dealData(item.data).variable.value
        const nextData = item.type === "Form" ? (variable && data[variable] ? data[variable] : data) : data
        if (item.type === "Form" && Array.prototype.isPrototypeOf(nextData) && data[variable]) {
          // 当form表单所绑定的参数为数组模式的时候，需要渲染特殊的模式
          window.setForm(item.id, nextData)
        } else {
          setChildItemData(item.childrenItems, nextData)
        }
        // 
      }
    })
  }
  // 初始化配置数据
  const makeData = async () => {
    console.log(jsonData, 'makeDatamakeDatamakeData')
    if (jsonData.type === 'page' || jsonData.type === 'widget') {
      jsonData.id = jsonData.id ? jsonData.id : new Date().getTime()
      jsonData.code = jsonData.id + '_' + jsonData.code
    }

    const allCodeNeedBack2 = getAllCode({ 'jsonData': jsonData })
    const allCodeNeedBack = getAllCode(jsonData.content)
    const interFaceAll = allCodeNeedBack.interfaceCode.concat(allCodeNeedBack2.interfaceCode)
    const dictAll = allCodeNeedBack.dictCode.concat(allCodeNeedBack2.dictCode)

    let contmap = {}
    if (allCodeNeedBack.componetCode.length !== 0) {
      const backData = await Api.getsWidgets({ 'code.in': allCodeNeedBack.componetCode.toString() })
      // console.log(backData)
      backData.list.map(item => {
        contmap[item.code] = item.layout
      })
    }
    let interFaceCode = {}
    if (interFaceAll.length !== 0) {
      const interkData = await Api.getsInteface({ "operationIdList": interFaceAll.toString() })
      // console.log(interkData)
      interkData.map(item => {
        // 临时写一下，因为basePath不对
        item.url = (Global.VariablePool.process.activeConfig.REAL_URL ? Global.VariablePool.process.activeConfig.REAL_URL : '') + '/services/' + item.basePath + item.api.replace(/{{1,}/g, '${')
        item.method = item.method.toLowerCase()
        interFaceCode[item.operationId] = { ...item }
      })
    }
    let dicCode = {}
    if (dictAll.length !== 0) {
      const idicData = await Api.getDictInfo({
        appCode: null,
        dictKeys: dictAll,
        isvCode: null,
        tenantCode: null,
        userCode: null
      })
      // console.log(interkData)
      idicData.map(item => {
        item.items.map(citem => {
          citem.label = citem.value
        })
        dicCode[item.dictKey] = item.items
      })
    }
    /*if (allCodeNeedBack.interfaceCode.length !== 0) {
      const interkData = await Api.getsInteface({ "codeList": allCodeNeedBack.interfaceCode.toString() })
      // console.log(interkData)
      interkData.map(item => {
        item.url = item.basePath + item.api
        item.method = toLowerCase(item.method)
        interFaceCode[item.code] = { ...item }
      })
    }*/
    jsonData.data.map(fitem => {
      if (fitem.code === 'initData' || fitem.code === 'submitUrl' || fitem.code === 'customColumn') {
        fitem.data = fitem.value ? interFaceCode[fitem.value] : null
      }
    })
    // console.log(jsonData.content, '==============', jsonData.childDataValue)
    for (let i in jsonData.content) {
      let scopeAll
      if (jsonData.content[i].type === "Button") {
        scopeAll = jsonData.content[i].data.filter(item => { return item.code === "scope" })
        // console.log(scopeAll, jsonData.content[i].data, Global.VariablePool.scope)
        if (scopeAll && scopeAll.length !== 0 && Global.VariablePool.scope && Global.VariablePool.scope[scopeAll[0].value] === false) {
          scopeAll = 'close'
        }
      }
      if (scopeAll !== 'close') {
        if (jsonData.content[i].type === "widget") {
          /**
           * 这里应该是走接口拿数据
           */
          const tempData = contmap[jsonData.content[i].code] // new Storage(Global.VariablePool.process).getStore('#' + jsonData.content[i].code)
          let id = jsonData.content[i].id
          let code = jsonData.content[i].code
          jsonData.content[i] = { ...jsonData.content[i], ...JSON.parse(tempData), id, code }//parseWidget(tempData)
        }
        /** 
       * 一个页面元素在同一个页面元素或者页面的时候被多次使用，会造成内部的子元素ID重复，
       * 但是当同一个页面元素被拖入其它页面元素的时候都会生成不同的id，但是数据库存储的code唯一，这样才能保证高度复用
       * 因此做了id转换，转换原则就是拿着父id+子id来做唯一id生成器
       * 因此在action当中有些方法设置的id也需要做些转换
       * 因为一些原因有些
       */
        const makeId = 'wp-' + jsonData.id + '-cp-' + i
        jsonData.content[i].id = jsonData.content[i].type === "widget" || jsonData.content[i].type === "page" ? jsonData.content[i].id : makeId
        /**
         * 除了page以外，其它的元素全部建立初始数据表，方便后面查找关系
         * 其中refs为了方便组件赋值，
         * wc为组件的基础信息，姓名，id，类型，父类id，属于高级还是低级
         * 在页面元素的时候还有一个特殊类型，用typeValue表示
         * */
        if (jsonData.content[i].type !== "page" && !Global.VariablePool.refs[jsonData.content[i].id] && !Global.VariablePool.wc[jsonData.content[i].id]) {
          Global.VariablePool.refs[jsonData.content[i].id] = Global.VariablePool.refs[jsonData.content[i].id] ? Global.VariablePool.refs[jsonData.content[i].id] : {}
          Global.VariablePool.refs[jsonData.content[i].id].refs = createRef(jsonData.content[i].id);
          Global.VariablePool.wc[jsonData.content[i].id] = Global.VariablePool.wc[jsonData.content[i].id] ? Global.VariablePool.wc[jsonData.content[i].id] : {}
          Global.VariablePool.wc[jsonData.content[i].id] = {
            id: jsonData.content[i].id,
            data: dealData(jsonData.content[i].data),
            style: dealData(jsonData.content[i].style),
            name: jsonData.content[i].name,
            type: jsonData.content[i].type,
            parent: jsonData.content[i].parent,
            mode: jsonData.content[i].mode,
            typeValue: dealData(jsonData.content[i].style).type ? dealData(jsonData.content[i].style).type.value : ''
          }
        }
        jsonData.content[i].data.map((ditem => {
          // 不同的组件会有一些不同的处理
          if (jsonData.content[i].type === "Radios" || jsonData.content[i].type === "CheckBoxes" || jsonData.content[i].type === "Select") {
            if (ditem.code === 'group') {
              ditem.data = ditem.value ? dicCode[ditem.value] : []
            }
          }
          if (jsonData.content[i].type === "Select") {
            if (ditem.code === 'localMap') {
              ditem.data = ditem.value ? JSON.parse(ditem.value) : ditem.data
            }
          }
          if (ditem.code === 'initData' || ditem.code === 'submitUrl' || ditem.code === 'customColumn') {
            ditem.data = ditem.value ? interFaceCode[ditem.value] : null
          }
          // console.log(jsonData.childDataValue)
          if (ditem.code === 'bind' && ditem.value && jsonData.childDataValue) {
            console.log(ditem, ditem.value, jsonData.childDataValue, jsonData.content[i],'bindbindbind')
            // console.log(jsonData.childDataValue)
            jsonData.content[i].value = jsonData.childDataValue[ditem.value] ? jsonData.childDataValue[ditem.value] : null
            Global.VariablePool.refs[jsonData.content[i].id].value = jsonData.content[i].value
           //console.log(jsonData.content[i].value,'bindbindbindbind')
          }
        }))
        jsonData.content[i].refTarget = Global.VariablePool.refs[jsonData.content[i].id].refs
        jsonData.content[i].action.map(citem => {
          if (citem.jsCode) {
            citem.jsCode = citem.jsCode.replace(/(this.setState){1,}/g, 'window.setState')
            citem.jsCode = citem.jsCode.replace(/(this.getState){1,}/g, 'window.getState')
            citem.jsCode = citem.jsCode.replace(/(message){1,}/g, 'window.message')
            const data = citem.jsCode.match(/(#[\/A-Za-z0-9_-]{1,})/g)
            if (data && citem.jsCode.lastIndexOf('openModal') === -1 && citem.jsCode.lastIndexOf('openDrawer') === -1 && citem.jsCode.lastIndexOf('addWidget') === -1) {
              data.map(item => {
                citem.jsCode = citem.jsCode.replace(item, 'wp-' + jsonData.id + '-cp-' + item)
              })
            }
          }
        })
        // 设置所有组件拥有的方法
        jsonData.content[i].dispatchEvent = (e, value) => {
          // console.log('str1', e, value)
          defaultFunction(e, value)
          jsonData.content[i].action.map(citem => {
            if (citem.key === e && citem.jsCode) {
              try {
                eval(citem.jsCode)
              } catch (error) {

              }
            }
          })
        }
      } else {
        delete jsonData.content[i]
      }
      // 当前页面元素的refs的注册，为后面可以设置数据直接渲染对饮给的元素准备
    }
    parseWidget(jsonData)
    //  console.log('==========', jsonData, endJSon)
    setEndJosn(jsonData)
  }

  /**
   * 复选组,日历,输入框,单选组,下拉框,开关
  */
  const defaultFunction = async (e, value) => {
    const type = value.props.componetType
    const id = value.props.id
    const parent = value.props.parent
    if (e === 'onChange') {
      switch (type) {
        case "Input":
          onChangeDefault({ id, value: value.value }, parent)
          break
        case "Radios":
          onChangeDefault({ id, value: value.value }, parent)
          break
        case "Switch":
          onChangeDefault({ id, value: value.value }, parent)
          break
        case "CheckBoxes":
          onChangeDefault({ id, value: value.value }, parent)
          break
        case "Select":
          onChangeDefault({ id, value: value.value }, parent)
          break
        case "DatePicker":
          console.log(value.value)
          onChangeDefault({ id, value: value.value.dateString }, parent)
          break
        case "Table":
          if (value.value) {
            let req = window.getRequest(id)
            req.page = value.value.current - 1
            req.size = value.value.pageSize
            const initData = value.props.data.initData.data
            const data = await axios[initData.method](initData.url, req);
            window.setState(id, data.data ? data.data : data)
            window.setRequest(id, req)
            // {...,page:value.value.page}
          }
          break
      }
    }
    if (e === 'onReset') {
      value.props.childrenItems.map(item => {
        window.setState(item.id, '')
      })
      searchSetData(value.props.data, value.props.childrenItems)
    }
    if (e === 'actionClick') {
      const action = value.value.action
      // const widgetCode = action.code ? new Storage(Global.VariablePool.process).getStore('#' + action.code) : null
      if ((action.action === "openModal" || action.action === "openDrawer")) {
        openWidget(('#' + action.code), value.props.id, value.value.record)
      }
      if (action.action === "openUrl") {
        const arraya = action.code.match(/(\/:[a-z,A-Z]{1,})/g)
        arraya.map((item) => {
          action.code = action.code.replace(item, ('/' + value.value.record[item.substr(2)]))
        })
        //console.log(action.code)
        window.location.href = action.code
      }
    }
    if (e === 'onTableHeaderClick') {
      const action = value.value.action.filter(item => { return item.key === "onClick" })
      buttonClickOpenDM(action[0], value.props.id)
    }
    if (e === 'onTableRowsChange') {
      window.setTabelRowsChoose(value.props.id, value.value)
    }
    if (e === 'onClick') {
      const action = value.props.action.filter(item => { return item.key === "onClick" })
      buttonClickOpenDM(action[0], value.props.id)
    }
    if (e === 'onArrayEdit') {
      // 为了避免重复渲染导致，input失焦，所以只是在全局变量上面设置了一个值而已
      Global.VariablePool.refs[value.props.id].value = value.childrenList
    }
    if (e === 'onSubmit') {
      const propsSubmit = value.props.data.submitUrl
      if (propsSubmit && propsSubmit.value) {
        let url = propsSubmit.data.url
        const getData = window.getState(value.props.id)
        // console.log(url, getData, 'onSubmitonSubmitonSubmit')
        url = getRealUrl(url, getData)
        let submitData = null
        if (value.props) {
          submitData = submitData ? submitData : {}
          formSubmit(value.props.childrenItems, submitData)
          /// console.log(submitData)
          if (Global.VariablePool.pageInit) {
            submitData = { ...submitData, ...Global.VariablePool.pageInit }
          }

        }
        // return
        await axios[propsSubmit.data.method](url, submitData);
        closeParent(value.props.id)
      }
    }
    if (e === 'onCancel') {
      closeParent(value.props.id)
    }
  }
  const formSubmit = (children, submitData) => {
    children.map(item => {
      if (item.type === 'Form') {
        const variable = dealData(item.data).variable.value
        if (variable) {
          if (Global.VariablePool.refs[item.id].value) {
            submitData[variable] = Global.VariablePool.refs[item.id].value
          } else {
            formSubmit(item.childrenItems, submitData)
          }
        } else {
          if (Global.VariablePool.refs[item.id].value) {
            Toast.error('message', '子表单配置有误')
          } else {
            formSubmit(item.childrenItems, submitData)
          }
        }
      } else {
        const bindKey = dealData(item.data).bind.value
        submitData[bindKey] = Global.VariablePool.refs[item.id].value
      }
    })
  }
  const buttonClickOpenDM = (action, id) => {
    if (action) {
      const code = action.jsCode.match(/(#[\/A-Za-z0-9_-]{1,})/g)
      const newRule = action.jsCode.lastIndexOf('openModal(') !== -1 || action.jsCode.lastIndexOf('openDrawer(') !== -1
      // console.log(action.jsCode, code)
      if (code && code[0] && newRule) {
        openWidget(code[0], id, null)
        return
      }
    }
  }
  const closeParent = (id) => {
    const fahter = id.split('-cp-')[0].match(/(#[\/A-Za-z0-9_-]{1,})/g)
    if (fahter && fahter[0]) {
      const type = Global.VariablePool.wc[fahter[0]].typeValue
      if (type === 'Drawer' || type === 'Modal') {
        setVisible(false)
      }
    }
  }
  // 用弹框和抽屉打开某个元素
  const openWidget = async (code, openEr, defaultValue) => {
    const widgetCode = code ? await Api.getsWidgetsCode(code.replace('#', '')) : null
    console.log(JSON.parse(widgetCode.layout), defaultValue, openEr)
    console.log(window.getTabelRowsChoose(openEr))
    //  const widgetCode = code ? new Storage(Global.VariablePool.process).getStore(code) : null
    if (widgetCode) {
      const div = document.createElement('div');
      const divId = 'w' + new Date().getTime()
      div.setAttribute('id', divId)
      document.body.appendChild(div)
      const propsData = { ...JSON.parse(widgetCode.layout) }
      if (openEr.lastIndexOf('Table_') !== -1 && window.getTabelRowsChoose(openEr)) {
        console.log('------------------')
        propsData.childDataValue = window.getTabelRowsChoose(openEr)
      } else {
        propsData.childDataValue = defaultValue
      }
      // propsData.childDataValue = defaultValue// value.value.record
      propsData.opener = openEr //value.props.id
      propsData.divId = divId
      // console.log(propsData)
      ReactDOM.render(<ComponetsRender {...propsData} ></ComponetsRender>, div)
    }
  }
  const onChangeDefault = (itemO, parent) => {
    // console.log(jsonData)
    Global.VariablePool.refs[itemO.id].value = itemO.value
    if (jsonData.content[parent] && jsonData.content[parent].type === "Search") {
      const Data = dealData(jsonData.content[parent].data)
      if (countTime) {
        return
      }
      countTime = setTimeout(async () => {
        countTime = null
        searchSetData(Data, jsonData.content[parent].childrenItems)
        return
      }, 500)
    }
  }
  const searchSetData = async (Data, children) => {
    let submitData = {}
    children.map(item => {
      const bindKey = dealData(item.data).bind
      if (bindKey) {
        const bindKeyString = bindKey.value
        if (bindKeyString.lastIndexOf('[') !== -1 && bindKeyString.lastIndexOf(']') !== -1) {
          try {
            const keyS = JSON.parse(bindKeyString)
            const tR = Global.VariablePool.refs[item.id].value ? Global.VariablePool.refs[item.id].value : null
            submitData[keyS[0]] = tR && tR[0] ? tR[0] : null
            submitData[keyS[1]] = tR && tR[1] ? tR[1] : null
          } catch (error) {
            console.error(error)
          }
        } else {
          submitData[bindKeyString] = Global.VariablePool.refs[item.id].value ? Global.VariablePool.refs[item.id].value : null
        }
        console.log(bindKeyString, submitData[bindKeyString])
      } else {
        const indexId = item.id.lastIndexOf('#')
        Toast.error('message', '组件' + item.id.substr(indexId) + '没有绑定参数，请检查')
      }
    })
    if (Data.initData && Data.initData.data) {
      const changeElement = Data.updateCompent.value ? jsonData.content[Data.updateCompent.value].id : null
      let req = { ...window.getRequest(changeElement), ...submitData, page: 0, size: 10 }
      for (let i in req) {
        if (req[i] === null || req[i] === undefined) {
          delete req[i]
        }
      }
      const data = await axios[Data.initData.data.method](Data.initData.data.url, req);
      if (changeElement) {
        window.setState(changeElement, data.data ? data.data : data)
        window.setRequest(changeElement, req)
      }
    }
  }
  const MDSure = async () => {
    const submit = jsonData.data.filter(item => { return item.code === 'submitUrl' })
    // console.log(submit, jsonData.childDataValue)
    if (submit && submit[0].value) {
      let url = submit[0].data.url
      url = getRealUrl(submit[0].data.url, jsonData.childDataValue)
      let submitData = null
      let error = null
      if (jsonData.content) {
        for (let i in jsonData.content) {
          if (jsonData.content[i].mode === 'base' && jsonData.content[i].type !== "Text") {
            submitData = submitData ? submitData : {}
            const dataObj = dealData(jsonData.content[i].data)
            const bindKey = dataObj.bind.value
            if (dataObj.regx && dataObj.regx.value) {
              const reg = regData(dataObj.regx.value, Global.VariablePool.refs[jsonData.content[i].id].value)
              if (!reg) {
                error = jsonData.content[i]
              }
            }
            if (dataObj.customRegx && dataObj.customRegx.value) {
              const testReg = dataObj.customRegx.value.substr(1, dataObj.customRegx.value.length - 2)
              if (!new RegExp(testReg).test(Global.VariablePool.refs[jsonData.content[i].id].value)) {
                error = jsonData.content[i]
              }
            }
            submitData[bindKey] = Global.VariablePool.refs[jsonData.content[i].id].value
          }
        }
      }
      // console.log(error)
      if (error) {
        Toast.error('message', dealData(error.data).label.value + '不符合输入规则')
        return
      }
      // 奇怪的写法，应该是要出于控制的状态
      submitData = submitData // ? submitData : { finishBy: "洗衣服", finishByCode: 'aaa071b4ae5248d4b50dba4749abbd34' }
      console.log(jsonData.opener, 'jsonData.openerjsonData.openerjsonData.opener')
      await axios[submit[0].data.method](url, submitData);
      if (jsonData.opener) {
        const urlData = window.getUrlData(jsonData.opener)
        const req = window.getRequest(jsonData.opener)
        const data = await axios[urlData.method](urlData.url, req);
        window.setState(jsonData.opener, data.data ? data.data : data)
      }
    }
    setVisible(false)
    document.getElementById(jsonData.divId).remove();
  }
  const MDClose = () => {
    setVisible(false)
    document.getElementById(jsonData.divId).remove();
  }
  const render = () => {
    if (!endJSon) {
      return null
    }
    let model
    let styleString = {}
    endJSon.style.map(item => {
      if (item.code === "type") {
        model = item.value ? item.value : ''
      } else {
        if (item.value) {
          styleString[item.code] = !isNaN(item.value) ? item.value * 1 : item.value
        }
      }
    })
    let title = ''
    endJSon.data.map(item => {
      if (item.code === "label") {
        title = item.value
      }
    })
    if (model && model === "Modal" && visible) {
      return <ConfigProvider locale={zhCN} autoInsertSpaceInButton={false}> <Modal title={title} style={styleString} {...styleString} visible={visible} onCancel={MDClose} onOk={MDSure}>
        <WidgetRender data={endJSon}></WidgetRender>
      </Modal></ConfigProvider>
    }
    const wstyle = styleString.width ? styleString.width : 256
    delete styleString.width
    if (model && model === "Drawer" && visible) {
      return <Drawer
        title={title}
        width={wstyle}
        style={styleString}

        visible={visible}
        getContainer={false}

        placement="right"
        onClose={MDClose}
        footer={
          <div
            style={{
              textAlign: 'right',
            }}
          >
            <Button onClick={MDClose} style={{ marginRight: 8 }}>
              取消
            </Button>
            <Button onClick={MDSure} type="primary">
              提交
            </Button>
          </div>
        }><WidgetRender data={endJSon}></WidgetRender></Drawer>
    }
    if (endJSon) {
      // console.log(endJSon)
      return <WidgetRender data={endJSon}></WidgetRender>
    }
    return null;
  }
  return <div className={style.mayiRender}>{render()}
  </div>
}
export default initWidget;
