import React, { useEffect } from 'react';
import style from './index.module.less';
import Global from '../Util/Global';
import { Toast } from 'mayihr-components'
import WidgetRender from './WidgetRender'
// import Api from './Api'
/**
 * 因为eval的一些作用域的问题，以及他执行的时候一定需要真实存在，他会直接去拿外部真实拥有的东西比如在window上的
 * 因此一些东西需要直接写在window上面
 * 
 * table在设置了行选择的属性的时候，会触发window.setTabelRowsChoose
 * 如果其它元素想使用当前table设置的行选择数据，使用window.getTabelRowsChoose
*/

window.setState = (id, value) => {
    Global.VariablePool.refs[id].refs.current.setValue(value)
    Global.VariablePool.refs[id].value = value
}
window.setOption = (id, value) => {
    Global.VariablePool.refs[id].refs.current.setOption(value)
    // Global.VariablePool.refs[id].value = value
}
window.setForm = (id, value) => {
    Global.VariablePool.refs[id].refs.current.setFormListValue(value)
}
// 设置table行被选择的数据
window.setTabelRowsChoose = (id, value) => {
    Global.VariablePool.refs[id].rows = value
}
// 获取table行被选择的数据
window.getTabelRowsChoose = (id, value) => {
    return Global.VariablePool.refs[id].rows
}
window.getState = (id) => {
    return Global.VariablePool.refs[id].value
}
window.message = (content, duration) => {
    Toast.success('message', { content, duration })
}
window.setRequest = (id, value, urlData) => {
    Global.VariablePool.refs[id].request = value
    if (urlData) {
        Global.VariablePool.refs[id].urlData = urlData
    }
}
window.getRequest = (id) => {
    return Global.VariablePool.refs[id].request
}
window.getUrlData = (id) => {
    return Global.VariablePool.refs[id].urlData
}
export default (props) => {
    useEffect(() => {
    }, [])
    if (props.config) {
        Global.VariablePool.process = props.config
    }
    if (props.scope) {
        Global.VariablePool.scope = props.scope
    }
    if (props.pageInit) {
        Global.VariablePool.pageInit = props.pageInit
    } else {
        delete Global.VariablePool.pageInit
    }

    if (!props.reph) {
        Global.VariablePool.refs = {}
        Global.VariablePool.wc = {}
    }
    const render = () => {
        return <WidgetRender data={props.data}></WidgetRender>
    }

    return <div className={style.mayiRender}>{render()}
    </div>
};


