import { message } from 'antd';

import axios from 'axios';
import { Base64 } from 'js-base64';
// import Config from '../config/Config';
import Storage from './Storage';
import global from './Global';

import { idempotent } from './Dict';

message.config({
  top: 200,
});
let Config = global.VariablePool.process || {
  activeConfig: {
    REACT_APP_DOMAIN: 'https://paas.mayitest.cn/',
    routerMode: 'hash',
    appId: 'mayihrhmcpublic',
    appSercert: 'TnKElW9eBGPQqRqU',
    appCode: 'LOWERCODE',
    login: ''
  }
}
let lStorage = new Storage(Config)
const CancelToken = axios.CancelToken;
const source = CancelToken.source();
global.VariablePool.idempotentToken = global.VariablePool.idempotentToken ? global.VariablePool.idempotentToken : [];
const getMayiToken = () => {
  return axios
    .get(Config.activeConfig.REACT_APP_DOMAIN + 'public/api/gateway/mayi-token?fetchCount=300')
    .then((res) => {
      global.VariablePool.idempotentToken = res.data.tokenList;
    });
};

// tslint:disable-next-line: no-any
let instance = axios.create({
  baseURL: Config.activeConfig.REACT_APP_DOMAIN, // window.location.origin,
  cancelToken: source.token,
  /*baseURL:
    Config.activeConfig.ENV.REACT_APP_STAGE !== 'bajie'
      ? 'http://' + window.location.host + '/api'
      : Config.activeConfig.REACT_APP_DOMAIN,*/
});
// 上电文拦截器
instance.interceptors.request.use(
  config => {
    //  const global = JSON.parse(new Storage().getStore('global'));
    const token =
      lStorage.getStore('token') && lStorage.getStore('token') !== '{}'
        ? lStorage.getStore('token')
        : '';
    if (token) {
      // const token = global.token;
      // config.headers.Authorization = 'Bearer ' + token;
    }
    return config;
  },
  err => {
    return Promise.reject(err);
  }
);


const dealNewHeader = (url) => {
  if (Config !== global.VariablePool.process) {
    Config = global.VariablePool.process
    lStorage = new Storage(Config)
    instance = axios.create({
      baseURL: Config.activeConfig.REACT_APP_DOMAIN, // window.location.origin,
      cancelToken: source.token,
      /*baseURL:
        Config.activeConfig.ENV.REACT_APP_STAGE !== 'bajie'
          ? 'http://' + window.location.host + '/api'
          : Config.activeConfig.REACT_APP_DOMAIN,*/
    });
  }
  const urls = [
    { des: 'G01-1101 获取RSA加密公钥（开放） GET', url: '/services/uaa/api/oauth/getPublicKey', noneHeader: true },
    { des: 'G01-1105 手机号登录（服务端通信，IP限制）POST', url: '/services/uaa/api/oauth/phone' },
    { des: 'G01-1106 密码登录-带图形验证码（开放）POST', url: '/services/uaa/api/oauth/password' },
    { des: 'G01-1107 密码登录-不带图形验证码（开放）POST', url: '/services/uaa/api/oauth/password-noCaptcha' },
    { des: 'G01-1108 登录获取短信验证码（开放）POST', url: '/services/uaa/api/oauth/verification-code/init' },
    { des: 'G01-1109 手机验证码登录（开放）POST', url: '/services/uaa/api/oauth/verification-code' },
    { des: 'G01-1102 注册（开放）POST', url: '/services/uaa/api/oauth/register' },
    { des: 'G01-1103 注册获取短信验证码（开放）POST', url: '/services/uaa/api/oauth/mobile-register/init' },
    { des: 'G01-1104 手机号注册（开放）POST', url: '/services/uaa/api/oauth/mobile-register' },
    { des: 'G01-1123 查询手机号是否存在对应用户 POST', url: '/services/uaa/api/oauth/mobile-check', noneHeader: true },
    { des: ' 根据inviteCode查询信息 GET', url: '/services/hmc/public/api/invitations', noneHeader: true },
    { des: ' 根据inviteCode查询信息 GET', url: '/services/lcdp/api/public/widgets/', noneHeader: true },
    { des: ' 根据inviteCode查询信息 GET', url: '/services/lcdp/api/public/operationzs/batch-detail', noneHeader: true },
    { des: ' 根据inviteCode查询信息 GET', url: 'public/api/gateway/mayi-token', noneHeader: true },
    {
      des: 'G01-1201 找回密码-发送验证码，初始化resetKey（开放）POST',
      url: '/services/uaa/api/oauth/reset-password/init',
    },
    {
      des: 'G01-1202 找回密码-校验短信验证码，返回resetKey（开放）POST',
      url: '/services/uaa/api/oauth/reset-password/reset-key',
    },
    { des: 'G01-1203 找回密码-修改密码（开放）POST', url: '/services/uaa/api/oauth/reset-password/finish' },
    { des: 'G01-1204 修改密码-判断原密码是否正确 POST', url: '/services/uaa/api/check-password' },
    { des: 'G01-1205 修改密码 POST', url: '/services/uaa/api/change-password' },
  ];
  const token =
    lStorage.getStore('token') && lStorage.getStore('token') !== '{}' ? lStorage.getStore('token') : '';
  // const token = global.token ? global.token : '';
  // console.log(token, Config, global.VariablePool.process)
  let header = {};
  header = { Authorization: 'Bearer ' + token };
  let needFliter = false;
  urls.map(item => {
    if (url.lastIndexOf(item.url) !== -1) {
      needFliter = true;
      if (item.noneHeader) {
        header = {};
      } else {
        header = {
          Authorization: `Basic ${Base64.encode(`${Config.activeConfig.appId}:${Config.activeConfig.appSercert}`)}`,
        };
      }
    }
  });
  if (!needFliter) {
    header = { Authorization: 'Bearer ' + token };
  }
  return header;
};
const suscess = (response) => {
  // console.log(response, 'interceptorsinterceptorsinterceptors')
  if (response.data) {
    if (response.headers && response.headers['x-total-count']) {
      response.data = { list: response.data, total: Number(response.headers['x-total-count']) };
      return response;
    }
    return response;
    // token失效返回登录页
  }
  if (response.status === 201) {
    return { data: true };
  }
  if (response.status < 300 && response.status > 100) {
    return response;
  }
  throw response;
}
const errorF = (error) => {
  message.destroy();
  if (error.response) {
    switch (error.response.status) {
      case 400:
        message.error(error.response.data.title);
        break;
      case 401:
        if (global.VariablePool.loginUrl) {
          window.location.href = global.VariablePool.loginUrl
          return
        }
        message.error(error.response.data.message || '用户没有权限（令牌、用户名、密码错误）。');
        break;
      case 403:
        message.error('用户得到授权，但是访问是被禁止的。', 1);
        break;
      case 404:
        message.error('发出的请求针对的是不存在的记录，服务器没有进行操作。');
        break;
      case 406:
        message.error('请求的格式不可得。');
        break;
      case 409:
        message.error('由于与一些已经确立的规则相冲突，提交的请求无法完成');
        break;
      case 410:
        message.error('请求的资源被永久删除，且不会再得到的。');
        break;
      case 417:
        message.error(error.response.data.message || '当创建一个对象时，发生一个验证错误。');
        break
      case 420:
        message.error(error.response.data.message || '当创建一个对象时，发生一个验证错误。');
        break
      case 422:
        message.error(error.response.data.message || '当创建一个对象时，发生一个验证错误。');
        break;
      case 429:
        message.error('请求过于频繁，请稍后再试');
        break;
      case 500:
        message.error('服务器发生错误，请检查服务器。');
        break;
      case 502:
        message.error('网关错误。');
        break;
      case 503:
        message.error('服务不可用，服务器暂时过载或维护。');
        break;
      case 504:
        message.error('网关超时。');
        break;
      default:
        if (String(error.response.status).match(/(4\d{1,})/g)) {
          message.error('请求包含语法错误或无法完成请求。');
        } else {
          message.error('服务器在处理请求的过程中发生了错误。');
        }
    }
  }
}
// 下电文拦截器
// instance.interceptors.response.use(suscess, errorF);
export default {
  // 因为axios 定义了返回值的类型 AxiosResponse 所以这里手动去掉一层
  post: async (url, data) => {

    const headers = {
      ...dealNewHeader(url),
      'Content-Type': 'application/json;charset=UTF-8',
    };
    if (idempotent.lastIndexOf(url) !== -1) {
      global.VariablePool.needRetury = url;
      if (global.VariablePool.idempotentToken.length === 0) {
        await getMayiToken();
      }
      headers['X-Mayi-Token'] = global.VariablePool.idempotentToken[global.VariablePool.idempotentToken.length - 1];
    }
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }
    // headers = { ...headers, 'Content-Type': 'application/json;charset=UTF-8' };
    return instance
      .post(url, data, { headers })
      .then(res => {
        if (idempotent.lastIndexOf(url) !== -1) {
          global.VariablePool.idempotentToken.pop();
        }
        return res.data;
      });
  },
  put: async (url, data) => {
    const headers = dealNewHeader(url);
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }

    return instance
      .put(url, data, { headers })
      .then(res => {
        return res.data;
      });
  },
  delete: async (url, data1) => {
    const headers = dealNewHeader(url);
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }

    return instance.delete(url, { data: data1, headers }).then(res => {
      return res.data;
    });
  },
  patch: async (url, data1) => {
    const headers = dealNewHeader(url);
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }
    return instance
      .patch(url, data1, { headers })
      .then(res => {
        return res.data;
      });
  },
  /**
   *
   * @param url
   * @param params
   * @param resType  请求类型 用来决定返回参数
   */

  get: async (url, params, resType) => {
    const headers = dealNewHeader(url)
    // console.log(url, 'interceptorsinterceptorsinterceptors', instance.interceptors.response)
    instance.interceptors.response.handlers = []
    // console.log(instance.interceptors.response.handlers.length, instance.interceptors.response.handlers)
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }
    return instance
      .get(url, { params, responseType: resType, headers })
      .then(res => {
        return res.data;
      });
  },

  // tslint:disable-next-line:no-any
  upload: async (url, formData) => {
    if (instance.interceptors.response.handlers.length === 0) {
      instance.interceptors.response.use(suscess, errorF);
    }
    const token =
      lStorage.getStore('token') && lStorage.getStore('token') !== '{}'
        ? lStorage.getStore('token')
        : '';
    const headers = {
      'Content-Type': 'multipart/form-data',
      Authorization: 'Bearer ' + token,
    };
    return instance
      .post(url, formData, { headers })
      .then(res => {
        return res.data;
      });
  },
};
